//================================================================
// EQX game engine
//
// - types
//
// AUTHOR:  Gabor Nagy
// DATE:    2017-Feb-01 08:31:17
//
// Copyright (C) 1994-2021 By Gabor Nagy. All rights reserved.
//================================================================
#include <E3D/IO.h>



typedef struct
{
	char          LabelFont[128],	LabelBoldFont[128],  // Labels
	              Header1Font[128],                    // Big font for titles
	              FinePrintFont[128],                  // Fine print
	              DropDownPanelFont[128],                     // Drawer names
	              MenuFont[128],                       // Menu
	              ListFont[128],                       // In lists, e.g. file selection boxes
	              TextFieldFont[128],                  // For editable text-fields
	              NumFont[128],                        // Numbers in text-fields
	              FixedFont[128];                      // Fixed width font
	char*         ModelFilterList;
	E3dIOModule*  ModelSaveFormat;
	E3dIOModule*  HierarchySaveFormat;
	E3dIOModule*  SceneSaveFormat;

	int           WindowSize[2];

// User interface
//
#ifndef __APPLE__
	EBool         OldMenuShadows;
#endif
	EBool         SelectAndFocusOnName;

	EBool         MenuBarOn,
	              ModelPanelOn, PicturePanelOn;
	EBool         KeepFileOpenDialogAfterOK;
	EBool         AskBeforeExit,
	              SelectHierarchyAfterLoading,
	              ReadSessionFromScene, DeleteAllBeforeReadingScene,
	              ModelFormatFromExtension,
	              HierarchyFormatFromExtension,
	              SceneFormatFromExtension;
} EqxPrefs;


extern void  _StaticLoadPlugins(void);


//----------------------------------------
// Plugins.c
//----------------------------------------
extern void  E3dp_SavePluginSettings(void);


//----------------------------------------
// Prefs.c
//----------------------------------------
extern void  E3dp_PreferencesInit(const int PArgc, const char* const* PArgv);
