//================================================================
// EQUINOX-3D
//
// - Application externs
//
// AUTHOR:  Gabor Nagy
// DATE:    2018-Apr-01 04:36:41
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//================================================================
#include "EQXTypes.h"

extern char*   Eqx_LoadedFileName;
extern char*   Eqx_RenderToFileName;

extern Widget  Eqx_ModelPanelW, Eqx_PicturePanelW,
               Eqx_TopWidget, Eqx_TopMatrixW,
               Eqx_MenuBarW;

extern EqxPrefs  Eqx_Prefs;

extern char*     Eqx_VersionString;

extern char      Eqx_ModelPath[];


extern EBool     Eqx_SavePreferences(void);


//----------------------------------------
// editing.c
//----------------------------------------
extern void      Eqx_UndoSettings(void);


//--------------------------------
// main.c
//--------------------------------
extern Widget  Eqx_TopShellW, Eqx_3DPanelW;

extern void    Eqx_SetTitle(const char* PFileName);
extern void    Eqx_UpdateColors(void);


//--------------------------------
// menu.c
//--------------------------------
extern XeMenuRec*  Eqx_MainMenuBar;

extern Widget  Eqx_3DWindowHeadersMenuBW,
               Eqx_MenuBarMenuBW,
               Eqx_TransformPanelMenuBW,
               Eqx_ToolBarMenuBW,
               Eqx_StatusPanelMenuBW,
               Eqx_TimePanelMenuBW,
               Eqx_FullScreenMenuBW;


#ifdef __APPLE__
extern int  Eqx_CocoaMenuBarCreate(void);
#endif

//------------------------------------------------
// menuf.c
//------------------------------------------------
extern E3dpWindow*  Eqx_WindowNew(E3dViewClass* PViewClass, const E3dRendererClass* PRendererClass);
 
extern void  EqxMCB_File(Widget PW, EPointer PClientData, EPointer PCallData);
extern void  EqxMCB_Edit(Widget PW, EPointer PClientData, EPointer PCallData);
extern void  EqxMCB_Window(Widget, EPointer, EPointer);
extern void  EqxKCB_Toggle3DWindowHeaders(const unsigned short PKey, const unsigned int PModifiers, const int PKeyEventType, EPointer PClientData);

extern void  EqxMCB_TogglePanel(Widget, EPointer, EPointer);

extern void  EqxMCB_ToggleFullScreen(Widget PW, EPointer PClientData, EPointer PCallData);
extern void  EqxKCB_ToggleFullScreen(const unsigned short PKey, const unsigned int PModifiers, const int PKeyEventType, EPointer PClientData);

extern void  EqxMCB_PluginManager(Widget, EPointer, EPointer);
extern void  EqxCB_SetToggle(Widget PW, EPointer PClientData, EPointer PCallData);


//------------------------------------------------
// E3MenuF.c
//------------------------------------------------
extern void  E3dpMCB_Debug(Widget PW, EPointer PClientData, EPointer PCallData);
extern void  EqxKCB(const unsigned short PKey, const unsigned int PModifiers, const int PKeyEventType, EPointer PClientData);

extern Widget  Eqx_AboutDialogW;

extern void    Eqx_About(void);


//------------------------------------------------
// prefs.c	
//------------------------------------------------
extern void	EqxMCB_Preferences(Widget PW, EPointer PClientData, EPointer PCallData);
