# Automatically derive both Active and Armed state from base image
#!/bin/sh +xv
#set -o verbose
export IMAGE=$1
export ScrCOMPILER="$2"
export ScrTARGET=$3
export TmpDIR=$4
export VERBOSE=

export EICONH_GAIN=2.0

export ICON128_DROPSHADOW="-o 12 12 -b 12  -B 32 32 32 0  -S 0 0 0 96"
export ICON128ACTIVE_DROPSHADOW="-o 12 12 -b 12  -B 32 32 32 0  -S 0 0 0 96"
export ICON128ARM_DROPSHADOW="-o 3 3 -b 5     -B 32 32 32 0  -S 0 0 0 96"
export ICON128BIG_DROPSHADOW="-o 7 7 -b 12    -B 32 32 32 0  -S 0 0 0 96"

# The more we crop here, the bigger the icon image will be,
# because it is then scaled to a fixed size...
#

export ICON128_CROP="0 0 0 0"

export ICON128ACTIVE_CROP="-12 -12 -12 -12"

export ICON128ARM_CROP="3 0 3 0"

export ICON128BIG_CROP="0 0 0 0"

export ESIZEX=48
export ESIZEY=48

$iCN $EITHREADS -c 0.64 Icons/images/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iDS $ICON128_DROPSHADOW  $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iCR $EITHREADS -c $ICON128_CROP $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iS -ma $EITHREADS -s $ESIZEX $ESIZEY $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE.c
$iCN $EITHREADS -c $EICONH_GAIN Icons/images/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iDS $ICON128ACTIVE_DROPSHADOW $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iCR $EITHREADS -c $ICON128ACTIVE_CROP $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iS -ma $EITHREADS -s $ESIZEX $ESIZEY $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE-Active.c
$iCN $EITHREADS -c $EICONH_GAIN Icons/images/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iDS $ICON128ARM_DROPSHADOW $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iCR $EITHREADS -c $ICON128ARM_CROP $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE.sgi
$iS -ma $EITHREADS -s $ESIZEX $ESIZEY $TmpDIR/$IMAGE.sgi $TmpDIR/$IMAGE-Armed.c;rm $TmpDIR/$IMAGE.sgi
cat $TmpDIR/$IMAGE.c $TmpDIR/$IMAGE-Active.c $TmpDIR/$IMAGE-Armed.c > $TmpDIR/$IMAGE-all.c;rm -f $TmpDIR/$IMAGE.c $TmpDIR/$IMAGE-Active.c $TmpDIR/$IMAGE-Armed.c
$ScrCOMPILER -c $TmpDIR/$1-all.c -o $ScrTARGET;rm -f $TmpDIR/$1-all.c
