//========================================================================
// Drawing macros etc.
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 05:19:52
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//========================================================================
#ifndef _E3D_PolyGroupDraw_h
#define _E3D_PolyGroupDraw_h

#ifndef _E3D_Draw_h
#include <E3D/GL/Draw.h>
#endif

#ifndef _E3D_GLVertexArrays_h
#include <E3D/GL/VertexArrays.h>
#endif

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


//================================================================
// Create VertexArray for a PolyGroup if necessary
//================================================================
static inline void E3dPolyGroup_GLCheckVertexArray(E3dPolyGroup* PPolyGroup,  const E3dVertex* PVertices, const E3dVertexSize PVertexSize,  const EIndex PVertices_Count)
{
	if(!PPolyGroup->GLArrayValid)
	{
//printf("%s() %s:%d  <<%s>>\n", __FUNCTION__, __FILE__, __LINE__, PPolyGroup->Name);fflush(stdout);
		E3dPolyGroup_GLCreateVertexArray(PPolyGroup,  PVertices, PVertexSize,  PVertices_Count);
	}
}


extern void  E3dPolyGroup_GLDrawConstSolid(E3dGPUContext* PGPUContext, E3dPolyGroup* PPolyGroup,  const E3dVertex* PVertices, const E3dVertexSize PVertexSize, const EIndex PVertices_Count,  const EcRGBAf32Color* PColor);
extern void  E3dPolyGroup_GLDrawConstSolidTextured(E3dGPUContext* PGPUContext, E3dGeometry* PGeometry, E3dPolyGroup* PPolyGroup,  const E3dVertex* PVertices, const E3dVertexSize PVertexSize, const EIndex PVertices_Count,  const EBool PTransparencyOn);


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"'
#endif

#endif	// _E3D_PolyGroupDraw_h
