//========================================================================
// Drawing macros for Splines and Faces
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 18:07:04
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//========================================================================
#ifndef _E3D_SplineDraw_h
#define _E3D_SplineDraw_h

#ifndef _E3D_Draw_h
#include <E3D/GL/Draw.h>
#endif

#ifndef _E3D_Face_h
#include <E3D/Face.h>
#endif

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

extern void  E3dSpline_Draw(E3dGPUContext* PGPUContext,  E3dSpline* PSpline, const int PSelection, const E3dDrawContext* PDrawContext, const E3dDisplayFlags PDisplayFlags);
extern void  E3dGL_SplineDrawForPick(E3dSpline* PSpline, const unsigned int PDisplayMode, const int PPickTargets);

extern void  E3dGL_FaceDrawContours(E3dGPUContext* PGPUContext,  E3dFace* PFace, const E3dDrawContext* PDrawContext, const E3dDisplayFlags PDisplayFlags);
extern void  E3dGL_FaceDrawSurface(E3dGPUContext* PGPUContext,  E3dModel* const PModel, E3dFace* PFace, E3dRenderer* PRenderer, const E3dDisplayFlags PDisplayFlags);
extern void  E3dGL_FaceDraw(E3dGPUContext* PGPUContext,  E3dModel* const PModel, E3dFace* PFace, E3dRenderer* PRenderer, const E3dDrawContext* PDrawContext, const E3dDisplayFlags PDisplayFlags);
extern void  E3dGL_FaceDrawForPick(E3dModel* const PModel, E3dFace* PFace, const E3dDrawContext* PDrawContext, const E3dDisplayFlags PDisplayFlags, const int PPickTargets);

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"'
#endif

#endif  // _E3D_SplineDraw_h
