//========================================================================
// GL VertexArrays
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 17:35:30
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//========================================================================
#ifndef _E3D_GLVertexArrays_h
#define _E3D_GLVertexArrays_h


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

#define E3dGL_GPU_SKINNING_MAX_JOINTS_PER_VERTEX  4

extern void  E3dPolyGroup_GLFreeRenderData(E3dPolyGroup* PPolyGroup);
extern void  E3dPolyGroup_FreeVertexArrays(E3dPolyGroup* PPolyGroup);
extern int   E3dPolyGroup_GLCreateVertexArray(E3dPolyGroup* PPolyGroup,  const E3dVertex* PVertices, const E3dVertexSize PVertexSize, const EIndex PVertices_Count);
extern void  E3dPolyGroup_FreeVertexArrays(E3dPolyGroup* PPolyGroup);

extern int   E3dPolyGroup_GLCreateVertexArrayExt(E3dPolyGroup* PPolyGroupN,  const E3dVertex* PVertices, const E3dVertexSize PVertexSize, const EIndex PVertices_Count,
  unsigned int*  PGLArraySizeP, void** PGLArrayP, unsigned int* PGLArrayVertexNodeSizeP,
  unsigned int** PGLArrayTriangleVertexIndicesP, EBool* PGLArrayTriangleVertexIndicesUseP, unsigned int* PGLArrayTriangleCountP,
  const EBool PForceIndexed, const EBool PCompactIndexedMode, const EBool PAlwaysAddNormals);


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif	// _E3D_GLVertexArrays_h
