//========================================================================
// E3D library
//
// - PointSet Geometry
//
// AUTHOR:  Gabor Nagy
// DATE:    2014-Feb-26 17:46:01
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//========================================================================
#ifndef _E3D_PointSet_h
#define _E3D_PointSet_h


#ifndef _E3D_Geometry_h
#include <E3D/Geometry.h>
#endif

#ifndef _E3D_Material_h
#include <E3D/Material.h>
#endif


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


typedef struct
{
	E3dCoord3       Position;
	EcRGBAf32Color  Color;
	EcRGBAp8Color   RGBAp8Color;
} E3dPoint;


enum
{
	E3dPOINTS = 1,
	E3dSPRITES
};

typedef struct
{
	E3dGeometryCore;

	char          RenderAs;
	int           PointSize;
	E3dMaterial*  Material;
	E3dMaterial*  DrawingMaterial;

	EList(, E3dPoint, Points);
} E3dPointSet;



extern E3dObjectClass  E3dPointSet_class[];


//--------------------------------------------------------
// Function prototypes
//--------------------------------------------------------
extern E3dPoint*  E3d_PointsNew(const EIndex PNumOfPoints);
extern EBool      E3dPointSet_GetBoundingBox(const E3dPointSet* PPointSet, const unsigned int PWhatToInclude,  E3dCoord3* PBBMin, E3dCoord3* PBBMax);


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif	// _E3D_PointSet_h
