//========================================================================
// EQUINOX-3D
//
// AUTHOR:  Gabor Nagy
// DATE:    2018-Apr-01 16:18:19
//
// Copyright (C) 1994-2021 By Gabor Nagy. All rights reserved.
//========================================================================
#ifndef _E3DP_CreateMacros_h
#define _E3DP_CreateMacros_h


#ifndef _E3D_Select_h
#include <E3D/Select.h>
#endif


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))

extern "C" {
#endif


//================================================================================
// Activation callback template for a Geometry with construction-history
//================================================================================
#define E3dTpl_ObjectComponentActivateCB_Geometry(mType, mPrefix,  mPlugin)\
do {\
	E3dObject*  lObject = NULL;\
\
	E3dModel*  lModel = E3dModel_CustomObjectNew(E3d_Scene, (E3dObjectComponentClass*)(mPrefix##ComponentClass), &lObject, (E3dp_Prefs.Duplicate_Flags & E3dCopyMODEL_UNIQUE_NAME) != 0);if(lModel)\
	{\
		E3dScene*     lScene = E3d_Scene;\
		E3dGeometry*  lGeometry = (E3dGeometry*)lObject;\
\
		lGeometry->AutoLOD = FALSE;\
\
		E3dScene_NodeHrcAdd(lScene, (E3dNode*)lModel, E3dUF_CALL_SCENE_CALLBACKS);\
\
		E3dScene_ObjectsUpdateModelList(lScene);E3dScene_LayoutOnSchematics(lScene, TRUE);\
\
		EChangeFlags  lChanged = E3dChgHIERARCHY|E3dChgSCHEMATICS;\
\
		if(lObject)\
		{\
			if(((XePushButtonCallbackStruct*)PCallData)->Reason == XeCR_ACTIVATE_OPTIONS) E3dObject_Edit(lObject, (mPrefix##ComponentClass));\
			lChanged |= E3dObject_GetChangeFlagsByClass(lObject);\
		}\
\
		if(E3dp_Prefs.SelectNewModels)\
		{\
			E3dSel_NodeSelectTree(lScene, (E3dNode*)lModel, TRUE, TRUE);\
			E3dTransformPanel_Update(NULL, E3dDoALL, E3dDoALL, E3dDoALL,  -1,  E3dTrPanelALL);\
		}\
\
		E3dWindows_RedrawByChangeFlags(lChanged);\
	}\
} while(0)

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif	// _E3DP_CreateMacros_h
