//========================================================================================================
// Directory compare tool
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 23:27:39
//
// Copyright (C) 1994-2021 By Gabor Nagy. All rights reserved.
//========================================================================================================
#ifndef _EDirCompare_h
#define _EDirCompare_h

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

#define EDirCompareCore\
	EList(, char*, FileExtensions);\
	EList(, char*, IgnoreDirs);\
	char*  Dir0;size_t  Dir0NameLen;\
	char*  Dir1;size_t  Dir1NameLen;\
	EBool  DoSymlinks, FollowSymlinks,\
         CheckContent, CheckMissing, CheckTimes, PreserveTimestamps, CreateTargetDirs,\
         IgnoreWhiteSpace, CompareBinaryFiles


typedef struct
{
	EDirCompareCore;
} EDirCompare;


extern int  EDirCompare_WalkDir(EDirCompare* PTool, const EBool PDoNFS, const EBool PDoSymlinks, const EBool PFollowSymlinks, unsigned long* PFullSizeRet, unsigned long* PNumOfFilesRet, unsigned long* PNumOfDirsRet, int (*PFunc)(EDirCompare*, char*, struct stat*, EBool));


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif // _EDirCompare_h
