//================================================================
// Default parameters header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2014-Feb-26 17:37:55
//
// Copyright (C) 1994-2021 By Gabor Nagy. All rights reserved.
//================================================================
#ifndef _EParam_h
#define _EParam_h


#include <ETypes.h>


#ifdef __cplusplus
extern "C" {
#endif



#ifdef WIN32
#include <windows.h>
#define EDir_lstat  stat
#endif

#ifdef UNIX
#define EDir_lstat  lstat
#endif


#ifdef WINDOWS
	#define ESLASH	'\\'
	#define MAXPATHLEN	256
	typedef short	nlink_t;
	#ifdef LCCC
		typedef short  uid_t;
		typedef short gid_t;
		typedef long  mode_t;
	#endif  // LCCC
	#define EDir_lstat	stat
#else
	#define ESLASH	'/'
	#include <sys/param.h>
	#define EDir_lstat	lstat
#endif // WINDOWS


#ifdef __cplusplus
}	// Close scope of 'extern "C"' declaration
#endif


#endif // _EParam_h
