//================================================================
// Xe Widget set
//
// Scripted GUI for EResources
//
// AUTHOR:  Gabor Nagy
// DATE:    2018-Apr-01 14:06:00
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//================================================================
#ifndef _EResourceGUI_h
#define _EResourceGUI_h

#include <stdarg.h>

#include <EResource.h>

#include <Xe/Xe.h>

#include <Xe/DropDownPanel.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

typedef struct
{
	Widget*  Widgets;EIndex  NumOfWidgets;  // One entry for each Resource. Might be NULL if the Resource has no UI member
} EResourcesGUI;


extern Widget  ERes_CreateWidget(const EResource* PResource, const ECoreObject* PObject, Widget PParentW, EResResourceCallbackProc PCallback, EPointer PClientData);
extern void    ERes_UpdateWidget(const EResource* PResource, ECoreObject* PObject, Widget PW);
extern void    ERes_ObjectAutoGUI(ECoreObject* PObject, EResourcesGUI** PResourcesGUIP, Widget PParentW, EResResourceCallbackProc PCallback, EPointer PClientData);
extern void    ERes_InfoObjectAutoGUI(ECoreObject* PObject, XeComponentClassDrawer* PDrawerIn, EResResourceCallbackProc PCallback, EPointer PClientData, const int PAction);

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}  // Close scope of 'extern "C"' declaration
#endif

#endif // _EResourceGUI_h
