//================================================================
// lib2D image library
//
// OpenGL textures
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 03:18:29
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//================================================================
#ifndef _Ep_GL_Texture_h
#define _Ep_GL_Texture_h


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

#define EpGL_MAX_BUFFERS_FOR_ANIMATED_TEXTURES  2


// OpenGL texture object
//
typedef struct
{
	EObjectCore(EObject);

	EpImage*      Image;            // EpImage of the texture for OpenGL, Vulkan etc. (if NULL, it's the same as Texture->Image)

	int           GLIndexForDrawing;
	int           PixelFormats[EpGL_MAX_BUFFERS_FOR_ANIMATED_TEXTURES];  // PixelFormat for the corresponding GLIndices
	unsigned int  GLIndices[EpGL_MAX_BUFFERS_FOR_ANIMATED_TEXTURES];     // GL index values. Multiple ones, so we can do double-buffering for animated textures
	EBool         NeedsSwapping;    // Texture changed. GLIndexForDrawing needs to be toggled

	EBool         Uploaded, FilteringUptodate;
} EpGLTexture;

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif	// _Ep_GL_Texture_h
