//================================================================================
// lib2D library
//
// Image header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 23:20:54
//
// Copyright (C) 2014-2021 by Gabor Nagy. All rights reserved.
//================================================================================
#ifndef _EGeoRef_h
#define _EGeoRef_h

#include <EGeo.h>

#ifdef USEGeoTIFF
#include "geokeys.h"

typedef struct
{
	int       Type, Count;
	void*     Data;
	geokey_t  id;
} EGeoKey;

typedef struct
{
	EpImageComponentCore;


	EGeoMapping  Mapping;


// GeoTIFFImage part
//
	char*  GeoTIFFString;        // GeoTIFF meta-file as string
	int    GeoTIFFStringLength;



/*
	double*  TiePoints;EIndex  TiePointsValueCount;
	double*  PixelScale;EIndex  PixelScaleValueCount;
	double*  Transformation;EIndex  TransformationValueCount;
*/

	EGeoKey*  Keys;EIndex  Keys_Count;

/*
	EResource*  Tags;EIndex  Tags_Count;
	EResource*  Keys;EIndex  Keys_Count;
*/
} EpGeoTIFFImageInfo;

#endif	// USEGeoTIFF


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif


#endif // _EGeoRef_h
