//================================================================
// lib2D
//
// Programmable lights. For example, CyCal (camera calibrator)
//
// AUTHOR:  Gabor Nagy
// DATE:    2016-Jun-17 14:39:42
//
// Copyright (C) 2014-2018 by Gabor Nagy. All rights reserved.
//================================================================
#ifndef _EpLight_h
#define _EpLight_h

#ifndef EClass_h
#include <EClass.h>
#endif  // EClass_h

#include <EThreads.h>

#include <Image/GL/Texture.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif



typedef struct EpLight_S                EpLight;
typedef struct EpLightClass_S           EpLightClass;



#define EpLightCore\
	EObjectCore(EpLight);\
	EcColor        Request_Color;\
	EcColor        Color;\
	EcRGBf32Color  RGBMin, RGBMax


struct EpLightClass_S
{
	EBaseClassCore(EpLight);

	int  (*SetColorRGB)(EpLight* PLight, const EcRGBf32Color* PColor);
};


extern EpLightClass   EpLight_class[];

extern EpLightClass*  Ep_LightClassRegister(EpLightClass* PClassTemplate);
extern int            Ep_LightClassDeactivate(EpLightClass* PClass);
extern EpLightClass*  Ep_LightClassByName(const char* PName);


struct EpLight_S
{
	EpLightCore;
};


extern EpLightClass  EpLight_class[];

EList(extern, EpLightClass*, Ep_LightClasses);

extern int    Ep_LightNew(EpLight* PLight, const char* PDevicePath);




#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}  // Close scope of 'extern "C"' declaration
#endif

#endif // _EpLight_h
