//========================================================================
// Skyline Robotics brushless DC motor driver control software
//
// AUTHOR:  Gabor Nagy
// DATE:    2016-Jul-03 04:22:37
//
// Copyright (C) 1994-2021 By Gabor Nagy. All rights reserved.
//========================================================================
#ifndef SR_BLMD_h
#define SR_BLMD_h

#include <SR/Motor.h>

typedef struct
{
	SrMotorDriverCore;

#ifdef __BEAGLEBONE__
// GPIO addresses GPIO port * 32 + pin (e.g. GPIO1_6 = 32 * 1 + 6 = 38)
// -1 : not used / invalid
//
	int16_t  DIRbit;
	int16_t  RESETbit;
	int16_t  ESFbit;
	int16_t  COASTbit;
	int16_t  BRAKEbit;
	int16_t  MODEbit;
#endif

	int  Current;
}	SrBLMD50;


extern void  Sr_BLMDTest(SrGPIO* PGPIO);

#endif // SR_BLMD_h
