//================================================================
// Xe UI toolkit
//
// XeBase
//  Common elements between XePrimitive and XeManager
//  This is not a true Widget class, just an instance-record
//  extension for shadows etc.
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 03:38:18
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//================================================================
#ifndef _XeBaseP_h
#define _XeBaseP_h

#include <Xe/XeP.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


//================================
// Instance definition
//================================
// Instance part
//================================
typedef struct
{
// Resources
//
	XeCoordinate   ShadowThickness;
	XeCoord2       MarginSize;XeCoordinate  MarginLeft, MarginRight, MarginTop, MarginBottom;

	EPointer       UserData, UserData1;

	XeString                ToolTipString;                   // ToolTip compound string
	char*                   ToolTipString8;                  // ToolTip plain string
	XeStringBinarySegment*  ToolTipStringBinary;int  ToolTipStringNumOfSegments;
	EInt32_2                ToolTipStringSize;


// Internal variables
//
	Widget          ToolTipShellW, ToolTipLabelW;
	XeIntervalId    ToolTipTimerId;

	EList(, EKeyRec, KeyTable);              // Key callbacks (see libsrc/Input.c)
} XeBasePart;


extern void         _XeBaseInit(Widget PW, XeBasePart* PXeBase,  const EArg* PArgs, const int PNArgs);
extern void         _XeBaseFree(Widget PW, XeBasePart* PXeBase);
extern XeBasePart*  XeWidgetGetBase(Widget PW);


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif // _XeBaseP_h
