//===============================================================================
// Xe UI toolkit
//
// XeMatrix
//  Public header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 19:07:39
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _Xe_ColumnList_h
#define _Xe_ColumnList_h

#include <Xe/Manager.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


#define XeColumnListEntryCore\
	EIndex    OrigIndex

typedef struct
{
	XeColumnListEntryCore;
} XeColumnListEntry;


#define XeColumnListEntryGUICore

typedef struct
{
	XeColumnListEntryGUICore;
} XeColumnListEntryGUI;


typedef struct
{
	Widget          HeaderW;
	EBool           WidthAdjustable;
	XeCallbackFunc  CallbackFunc;
} XeColumn;

typedef struct XeColumnList_S  XeColumnList;

typedef void (*XeColumnListUpdateFunc)(XeColumnList* PInputList, const EIndex PNEntries, EPointer PCallbackClientData);

#define XeColumnListCore\
	Widget   ScrolledWindowW, VScrollbarW, ClipWindowW, ListMatrixW;\
	EList(, XeColumn*, Columns);\
\
	int16_t  SortByColumn;\
	int8_t   SortDirection;\
\
	EListA(, XeColumnListEntry*, Entries);\
	XeColumnListEntry**  SortedEntries;\
	EListA(, XeColumnListEntryGUI*, EntriesGUI);\
\
	XeColumnListUpdateFunc  UpdateFunc;EPointer  UpdateFuncClientData

struct XeColumnList_S
{
	XeColumnListCore;
};


extern void  XeColumnList_Init(XeColumnList* PList);
extern void  XeColumnList_Create(XeColumnList* PInputList, Widget PParentW,  XeColumnListUpdateFunc PUpdateFunc, EPointer PUpdateFuncClientData,  ...);


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"' declaration
#endif

#endif // _Xe_ColumnList_h
