//================================================================================
// Xe GUI library
//
// FileSelectionBox private header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 06:55:36
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeFSBoxP_h
#define _XeFSBoxP_h

#include <Xe/Dialog.h>
#include <Xe/FSBox.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


typedef struct
{
	Widget  ListW;
} EGUIList;


typedef struct
{
 
} XeDirEntry;


typedef struct
{
	XeDialogCore;

	Widget            ShellW;
	Widget            ManagerW;
	Widget            FilterMatrixW, FilterTextW, FilterListBW,
	                  ListsMatrixW, FileLabelW, FileTextW;

	EGUIList          DirList;
	EGUIList          FileList;

	XeEntryIdFunc     EntryIdProc;

	Widget            ListsLayoutW, FilterListFormW, FilterListW;
	Widget            DirsScrolledWindowW, FilesScrolledWindowW,
	                  DirListLabelW, FileListLabelW, ViewModeMatrixW,
	                  SingleViewBW, DualViewBW,
	                  CustomItemW;
	Widget            FocusWidget;
	int               VScrollbarSizeX;
	int               FileListSizeX, ListXMargin, CustomItemPlacement, CustomItemType;
	int               SizeXDiff, SizeYDiff;
	int               SizeXWithLists, SizeYWithLists;
	unsigned int      DispFlags;
	char              DirFilter[MAXPATHLEN + 1];
	char              Path[MAXPATHLEN + 1];
	char              File[MAXPATHLEN + 1];
	EdirEntry*        DirEntries;
	EIndex            NumOfEntries, MaxNumOfEntries, NumOfDirs;
	char*             TmpFilterList;
	EguiCallbackList  ValueChangedCallback;

	XeIntervalId      DirMonitorTimer;
	time_t            DirLastUpdateMTime;

	uint16_t          MultiSelect:1, Mapped:1, DirListOn:1, FileListOn:1, ShowLists:1;
	EBool             FileListVisibleItemCountGiven:1,
	                  ShowFullPaths:1, FilterListOn:1, PrgChangedSize:1;

	int               FileListVisibleItemCount;

	uint16_t          FileDeleteAction, FileActivateOnSelectWith;
} XeFileSelectionBox;



#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif


extern void  _XeFSBoxFree(void);


#endif	// _XeFSBoxP_h
