//===============================================================================
// Xe UI toolkit
//
// XeFrame
//  Private header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 04:32:39
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeFrameP_h
#define _XeFrameP_h

#include <Xe/ManagerP.h>
#include <Xe/Frame.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

//================================
// Class definition
//================================
// Class part
//================================
typedef struct _XeFrameClassPart
{
	EPointer  Extension;
} XeFrameClassPart;


//================================
// Class record
//================================
typedef struct _XeFrameClassRec
{
	XeCompositeClassCore;
	XeConstraintClassPart  Constraint;
	XeManagerClassPart     Manager;
	XeFrameClassPart       Frame;
} XeFrameClassRec;

extern XeFrameClassRec xeFrameClassRec;


//================================
// Instance definition
//================================
// Instance part
//================================
typedef struct
{
	XeCoord2      MarginSize;
	unsigned int  ShadowType;
	EBool         AdjustEntrySizeX, AdjustEntrySizeY;
} XeFramePart;



//================================
// Instance record
//================================
typedef struct _XeFrameRec
{
	XeCompositeWidgetCore;

	XeBasePart      Base;
	XeManagerPart   Manager;
	XeFramePart     Frame;
} XeFrameRec;


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif // _XeFrameP_h
