//===============================================================================
// Xe UI toolkit
//
// XeMatrix
//  Public header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 19:07:39
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeMatrixWidget_h
#define _XeMatrixWidget_h

#include <Xe/Manager.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

extern XeWidgetClass               XeMatrixWidget_class;
typedef struct _XeMatrixClassRec*  XeMatrixWidgetClass;
typedef struct _XeMatrixRec*       XeMatrixWidget;

#define XeCONTENT  0x01
#define XeHEADER   0x02

extern int   Xe_MatrixColumnPreferredSizeX(Widget PW, const int PColumn, const EBool PAddSpacing, const uint8_t PWhatToInclude);
extern int   Xe_MatrixColumnGetSpacingX(Widget PW, const int PColumn);
extern void  Xe_MatrixColumnSetSizeX(Widget PW, const int PColumn, const int PSizeX, const EBool PDoLayout);

extern int   Xe_MatrixRowSizeY(Widget PW, const int PRow);
extern void  Xe_MatrixGetPreferredSizeFromConstraints(XeMatrixWidget PEW, XeWidgetGeometry* PGeo);

extern Widget  Xe_TabPanelNew(Widget PParentW, const uint16_t PLayout);
extern Widget  Xe_TabPanelAddTab(const char* PName, Widget PW, Widget PNewPanelW);
extern void    Xe_TabPanelSetCurrentTab(Widget PW);

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"' declaration
#endif

#endif // _XeMatrixWidget_h
