//===============================================================================
// Xe UI toolkit
//
// XeMessageBox
//  Private header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 18:12:14
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeMessageBoxP_h
#define _XeMessageBoxP_h

#include <Xe/ManagerP.h>
#include <Xe/MessageBox.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

//================================
// Class definition
//================================
// Class part
//================================
typedef struct _XeMessageBoxClassPart
{
	EPointer  Extension;
} XeMessageBoxClassPart;


//================================
// Class record
//================================
typedef struct _XeMessageBoxClassRec
{
	XeCompositeClassCore;
	XeConstraintClassPart  Constraint;
	XeManagerClassPart     Manager;
	XeMessageBoxClassPart  MessageBox_class;
} XeMessageBoxClassRec;

extern XeMessageBoxClassRec  _XeMessageBox_class;



//================================
// Instance definition
//================================
// Instance part
//================================
typedef struct
{
	int             ButtonAlignment;

	XeCoord2        WorkAreaMarginSize;
	XeCoordinate    ButtonSpacing, ButtonsSizeY;

	Widget          WorkAreaW, SeparatorW;
	Widget*         Buttons;int		NumOfButtons;

	XeCallbackList  OkCallback, CancelCallback, HelpCallback;

	uint8_t         WorkAreaResizePolicyX, WorkAreaResizePolicyY;   // Tells whether MessageBox can resize its WorkArea child
	EBool           CreateSeparator, CreateButtons, ButtonsStretch, ButtonsUniformWidth;

// Private variables
//
	EBool           DoLayout;
} XeMessageBoxPart;


//================================
// Instance record
//================================
typedef struct _XeMessageBoxRec
{
	XeCompositeWidgetCore;

	XeBasePart        Base;
	XeManagerPart     Manager;
	XeMessageBoxPart  MessageBox;
} XeMessageBoxRec;


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"' declaration
#endif

#endif // _XeMessageBoxP_h
