//===============================================================================
// Xe UI toolkit
//
// XePushButton
//  Public header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2019-Jun-23 05:16:08
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XePushButton_h
#define _XePushButton_h

#include <Xe/Label.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

extern XeWidgetClass                   XePushButton_class;
typedef struct _XePushButtonClassRec*  XePushButtonClass;
typedef struct _XePushButtonRec*       XePushButton;

typedef struct
{
	XeCallbackStructCore;

	int           ClickCount;
	unsigned int  State;    // Modifier keys
} XePushButtonCallbackStruct;

extern void  XePushButton_Arm(Widget PW);
extern void  XePushButton_ArmSubButton(Widget PW);
extern void  XePushButton_Disarm(Widget PW);


extern int  Xe_PushButtonMarginTop;

extern EguiItemClass                     EguiPushButton_class;
typedef struct _EguiPushButtonClassRec*  EguiPushButtonClass;
typedef struct _EguiPushButtonRec*       EguiPushButton;


#define Xe_PushButtonAddImg3(mDst, mNameP, mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData) do\
{\
	mDst = XePushButton_AddImg(mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData,  _Image_##mNameP, _Image_##mNameP##_Active, _Image_##mNameP##_Armed,  EpSRC_plus_DSTxONE_MINUS_ALPHA);\
} while(0)

#define Xe_PushButtonAddImg3_shadow(mDst, mNameP, mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData) do\
{\
	mDst = XePushButton_AddImg(mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData,  _Image_##mNameP, _Image_##mNameP##_Active, _Image_##mNameP##_Armed,  EpSRC_plus_DSTxALPHA);\
} while(0)


//
// Original CImages are structs, targets are pointers
//
#define Xe_PushButtonAddImg2_sp(mDst, mNameP, mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData) do\
{\
	EpM_CreateIconStates2_sp(mNameP);\
	mDst = XePushButton_AddImg(mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData,  _Image_##mNameP, _Image_##mNameP##_Active, _Image_##mNameP,  EpSRC_plus_DSTxONE_MINUS_ALPHA);\
} while(0)

#define Xe_PushButtonAddImg3_sp(mDst, mNameP, mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData) do\
{\
	EpM_CreateIconStates3_sp(mNameP);\
	mDst = XePushButton_AddImg(mLocation, mName, mMnemonic, mAccel, mAccelText, mCreateOptionsButton, mToolTip, mCallback, mClientData,  _Image_##mNameP, _Image_##mNameP##_Active, _Image_##mNameP##_Armed,  EpSRC_plus_DSTxONE_MINUS_ALPHA);\
} while(0)




extern void  _XeCB_PushButton(Widget PW, EPointer PClientData, EPointer PCallData);

extern EguiItem  XePushButton_Add(const char* PLocation, const char* PName, const char PMnemonic, const char* PAccel, const char* PAccelText, const EBool PCreateOptionsButton, const char* PToolTip, XeCallbackFunc PCallback, EPointer PClientData);
extern EguiItem  XePushButton_AddImg(const char* PLocation, const char* PName, const char PMnemonic, const char* PAccel, const char* PAccelText, const EBool PCreateOptionsButton, const char* PToolTip, const XeCallbackFunc PCallback, const EPointer PClientData, const EpImage* PLabelImage, const EpImage* PActiveImage, const EpImage* PArmImage,  const int PImageAlphaBlendMode);


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"' declaration
#endif

#endif // _XePushButton_h
