//===============================================================================
// Xe UI toolkit
//
// XeScrolledWindow
//  Public header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2018-Apr-01 20:47:42
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeScrolledWindowWidget_h
#define _XeScrolledWindowWidget_h

#include <Xe/ScrollBar.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


enum { XeAUTOMATIC, XeAPPLICATION_DEFINED };

enum { /* XeSTATIC */ XeAS_NEEDED = 1 };

#define SW_TOP     1
#define SW_BOTTOM  0
#define SW_LEFT    2
#define SW_RIGHT   0

#define XeTOP_LEFT      (SW_TOP | SW_LEFT)
#define XeBOTTOM_LEFT   (SW_BOTTOM  | SW_LEFT)
#define XeTOP_RIGHT     (SW_TOP | SW_RIGHT)
#define XeBOTTOM_RIGHT  (SW_BOTTOM  | SW_RIGHT)


extern XeWidgetClass                       XeScrolledWindowWidget_class;
typedef struct _XeScrolledWindowClassRec*  XeScrolledWindowWidgetClass;
typedef struct _XeScrolledWindowRec*       XeScrolledWindowWidget;


extern void    XeScrolledWindow_SetAreas(Widget PWidget, Widget PHScrollbar, Widget PVScrollbar, Widget PWorkWindow);
extern Widget  XeScrolledWindow_New(Widget PParentW, const char* PName,  const EArg* PArglist, const int PArgCount);

extern Widget  XeScrolledWindow_TopHeaderAddButton(const char* PName, Widget PParentW,  EArg* PArgs, int PArgCnt);
extern void    XeScrolledWindow_TopHeaderSetDrivingMatrix(Widget PW,  Widget PMatrixW);
extern void    XeScrolledWindow_TopHeaderAddDrivingMatrix(Widget PW,  Widget PMatrixW);


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif // _XeScrolledWindowWidget_h
