//===============================================================================
// Xe UI toolkit
//
// XeSeparator
//  Private header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2017-May-24 03:10:45
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeSeparatorP_h
#define _XeSeparatorP_h

#include <Xe/PrimitiveP.h>
#include <Xe/Separator.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


//================================
// Class definition
//================================

#define XeSeparatorClassCore\
	XePrimitiveClassCore

typedef struct _XeSeparatorClassRec
{
	XeSeparatorClassCore;
} XeSeparatorClassRec;

extern XeSeparatorClassRec  _XeSeparator_class;


//================================
// Instance definition
//================================
// Instance part
//================================
typedef struct
{
// Resources
	unsigned int  ShadowType;
	char          Orientation;


// When Separator is in a Matrix
//
	EBool         Movable;
} XeSeparatorPart;


//================================
// Instance record
//================================
typedef struct _XeSeparatorRec
{
	XeWidgetCore;
	XeBasePart       Base;
	XePrimitivePart  Primitive;
	XeSeparatorPart  xeSeparator;
} XeSeparatorRec;


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"' declaration
#endif

#endif // _XeSeparatorP_h
