//================================================================================
// Xe Widget set
//
// Shell internals
//
// AUTHOR:  Gabor Nagy
// DATE:    2017-Sep-12 03:36:44
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeShellI_h
#define _XeShellI_h


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


#ifdef EX11
#define XeX11SA\
	Pixmap  X_IconPixmap

#else
#define XeX11SA
#endif


//------------------------------------------------------------------------
// Temporary resource values, used by XeShell_New
//------------------------------------------------------------------------
#define _XeShellArgsCore\
	char*     Title;\
	char*     IconName;EBool  TruecolorIcon;EBool   Iconify;int  IconX ,IconY;\
	int       SizeX, SizeY,  MinSizeX, MaxSizeX,  MinSizeY, MaxSizeY;\
	uint8_t   SelfResizePolicyX, SelfResizePolicyY;\
	int       WMFunctions, WMDecorations, DeleteResponse;XeCallbackFunc  WMCallback;\
	int       StackingPriority;\
	EpImage*  IconImage;\
	EpImage*  BackgroundImage;\
	XeColor   BackgroundColor;\
	EBool     ClearBackground;\
	Widget    CenterToWidget;\
	EBool     AllowShellResize, MappedWhenManaged;\
	EBool     SaveUnder, CreateIconFrame;\
	XeX11SA



typedef struct
{
	_XeShellArgsCore;
} _XeShellArgs;


extern void    _XeShellInitArgs(_XeShellArgs* PShellArgs);
extern Widget  _Xe_CreateThatShell(XeApp PApp, _XeShellArgs* PShellArgs, XeDisplay* PDisplay, const char* PName, Widget PParentW);

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"' declaration
#endif


#endif // _XeShellI_h
