//================================================================================
// Xe Widget set
//
// Main private header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2017-Jun-25 06:44:31
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeStringP_h
#define _XeStringP_h


//--------------------------------------------------------
// Strings
//--------------------------------------------------------
#define _XeMS_GetComponent(xs, s, c, n) do\
{\
	(c)++;\
	const uint8_t  lUCh = (xs)[c];\
	if(lUCh & 0x80) { (c)++;(n) = (xs)[c] * 256 + (xs)[c + 1];(c)++; }\
	else (n) = lUCh;\
	(c)++;\
	int  lC = 0;for(;lC < (n);lC++) (s)[lC] = (xs)[c + lC];\
	(s)[lC] = 0;(c) += (n);\
} while(0)


#define _XeMS_GetComponentPtr(mXeStr, mC, mN) do\
{\
	(mC)++;\
	const uint8_t  lUCh = (mXeStr)[mC];\
	if(lUCh & 0x80)\
	{\
		(mC)++;\
		(mN) = (mXeStr)[mC] * 256 + (mXeStr)[mC + 1];(mC)++;\
	}\
	else (mN) = lUCh;\
	(mC)++;\
} while(0)


#define _XeMS_InsertSize(xs, c, s) do\
{\
	if((s) <= 127) { (xs)[c] = s;(c) += 1; }\
	else\
	{\
		(xs)[LC++] = 128;\
		(xs)[LC++] = (uint8_t)(((s) >> 8) & 0xFF);(xs)[LC++] = (uint8_t)((s) & 0xFF);\
	}\
} while(0)


static inline void XeString_BinarySegmentInit(XeStringBinarySegment* PSegment)
{
	PSegment->Image        = NULL;
	PSegment->FontSize     = NULL;
	PSegment->Direction    = XeSTRING_DIRECTION_L_TO_R;
	PSegment->Alignment    = XeSTRING_ALIGN_DEFAULT;
	PSegment->AlignmentY   = XeSTRING_ALIGN_DEFAULT;
	PSegment->String       = NULL;
	PSegment->WString      = NULL;
	PSegment->Size.X = PSegment->Size.Y = 0;
	PSegment->Advance.X = PSegment->Advance.Y = 0;
	PSegment->InkLeft = PSegment->InkTop = 0;
	PSegment->Separator    = 0;
	PSegment->SetColor     = FALSE;

	EClr_s(PSegment->TextColor);

#ifdef EX11
	PSegment->X_TextColor  = 0;
	PSegment->X_Pixmap     = None;
#endif
}


#define _XeMS_AddSize(c, s) do\
{\
	if((s) <= 127) (c) += 1;else (c) += 3;\
} while(0)


#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif


extern int  _XeString_NumberOfSegments(XeString LXeStr);

extern void _XeString_DrawSegmentsInLine(XeStringDrawContext* PContext, const XeVisual* PVisual, EpImage* PTargetImage, const int PBlendMode, const int PDrawableSizeX, const float PBlurRadius,
 const XeStringBinarySegment* PSegments, const int PSegmentsInLine, const float PMaxAscent, const int PLineStart, const int PAlignment, const int PCurrentAlignment,
 const int PX, const int PYI, const int PLineSizeX, const int PFullSizeX, const EBool PUseColorsInString);

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
} // Close scope of 'extern "C"' declaration
#endif

#endif // _XeStringP_h
