//===============================================================================
// Xe UI toolkit
//
// XeToggleButton
//  Public header file
//
// AUTHOR:  Gabor Nagy
// DATE:    2017-Jun-02 04:57:02
//
// Copyright (C) 1994-2021 by Gabor Nagy. All rights reserved.
//===============================================================================
#ifndef _XeToggleButton_h
#define _XeToggleButton_h

#include <Xe/Label.h>

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
extern "C" {
#endif

extern XeWidgetClass                     XeToggleButton_class;
typedef struct _XeToggleButtonClassRec*  XeToggleButtonClass;
typedef struct _XeToggleButtonRec*       XeToggleButton;

enum
{
	XeButtonTypeTOGGLE = 0,
	XeButtonTypeLED,
	XeButtonTypeLIST_HEADER,
	XeButtonTypeMODE,
	XeButtonTypeTAB_TOP,     // Folder tab above
	XeButtonTypeTAB_BOTTOM,  // Folder tab below
	XeButtonTypeTAB_LEFT,    // Folder tab to the left
	XeButtonTypeTAB_RIGHT    // Folder tab to the right
};

enum
{
	XeN_OF_MANY = 0, XeONE_OF_MANY, XeN_OF_MANY_FULL_HEIGHT
};

typedef struct
{
	XeCallbackStructCore;

	int      ClickCount;
	EBool    Set;
	EBool    ValueChanged;
	uint8_t  ArrowDirection;
	EBool    ArrowDirectionChanged;
} XeToggleButtonCallbackStruct;

extern void      XeToggleButton_SetState(Widget PWidget, const EBool PValue, const EBool PNotify);
extern EBool     XeToggleButton_GetState(Widget PWidget);
extern void      XeToggleButton_Arm(Widget PW);
extern void      XeToggleButton_Disarm(Widget PW);
extern void      XeToggleButton_ArmSubButton(Widget PW);

//
// Deferred Widgets
//
extern EguiItemClass                       eguiToggleButtonClass;
typedef struct _EguiToggleButtonClassRec*  EguiToggleButtonClass;
typedef struct _EguiToggleButtonRec*       EguiToggleButton;

extern void  _XeCB_ToggleButton(Widget PW, EPointer PClientData, EPointer PCallData);

extern EguiItem  XeToggleButton_Add(const char* PLocation, const EBool PDefault, const char* PName, const char PMnemonic, const char* PAccel, const char* PAccelText, const EBool PCreateOptionsButton, const char* PToolTip,  XeCallbackFunc PCallback, EPointer PClientData);

#if defined (__cplusplus) && (!(defined (__CPLUSLIBS)))
}	// Close scope of 'extern "C"' declaration
#endif

#endif // _XeToggleButton_h
